package domaine;

public class GestionnaireDeCompteBancaire {
    private CompteBancaire compte;
    public GestionnaireDeCompteBancaire(int numeroDuCompte) {
        //on passe les paramètres de construction de l'objet du mandat
        //le mandataire construit l'objet du mandat
        compte = new CompteBancaire(numeroDuCompte);
        Journal.getInstance().ecrit("Ouverture du compte " + compte.numero() + ".");
    }
    public void depose(double montant) throws Exception {
        try {
            Journal.getInstance().ecrit("Dépôt de " + montant + "€ sur le compte " + compte.numero() + ".");
            compte.depose(montant);
        } catch (Exception e) {
            Journal.getInstance().ecrit("/!\\ "+e.getMessage());
        }
    }
    public void retire(double montant) throws Exception {
        try {
            Journal.getInstance().ecrit("Retrait de " + montant + "€ sur le compte " + compte.numero() + ".");
            compte.retire(montant);
        } catch (Exception e) {
            Journal.getInstance().ecrit("/!\\ " + e.getMessage());
        }
    }
    public int numero() {
        return compte.numero();
    }
    public double solde() {
        Journal.getInstance().ecrit("Consultation du solde du compte " + compte.numero() + ".");
        return compte.solde();
    }
    public String toString() {
        return compte.toString();
    }
    //pas d'autres méthodes publiques que celles qui sont définies
    //pour l'objet du mandat
}
