package domaine;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;

public class Journal {
    private static Journal uniqueInstance;// Stockage de l'unique instance de cette classe.
    private static DateFormat df = null;
    private class Article {
        String quand;
        String quoi;
        Article(String msg) {
            // On mémorise la date du message.
            Date d = new Date();
            if (df == null) df = new SimpleDateFormat("dd/MM/yy HH'h'mm");
            quand = df.format(d);
            quoi = msg;
        }
        public String toString() {
            return "[" + quand + "]" + quoi;
        }
    }
    private List<Article> contenu;// collection de tous les articles du journal.

    // Constructeur privé (donc inaccessible à l'extérieur de la classe).
    private Journal() {
        contenu = new LinkedList<Article>();
    }

    // Méthode statique qui sert de pseudo-constructeur (utilisation du mot clef "synchronized" pour le multithread).
    public static synchronized Journal getInstance() {
        if(uniqueInstance==null) {
            uniqueInstance = new Journal();
        }
        return uniqueInstance;
    }

    // Méthode qui permet d'ajouter un message au journal.
    public void ecrit(String msg) {
        contenu.add(new Article(msg));
    }

    public String toString() {
        StringBuffer texte = new StringBuffer();
        Iterator<Article> it = contenu.iterator();
        while (it.hasNext()) {
            texte.append(it.next() + "\n");
        }
        return texte.toString();
    }
}
